import 'package:bloc_stream/bloc_stream.dart';
import 'package:flutter_bloc_stream/flutter_bloc_stream.dart';
import 'package:flutter_hooks/flutter_hooks.dart';

import 'bloc_stream_provider.dart';

B useBlocStream<B extends BlocStream>() {
  final context = useContext();
  return useMemoized(() => BlocStreamProvider.of<B>(context));
}

S useBlocStreamState<B extends BlocStream<S>, S>() {
  final bloc = useBlocStream<B>();
  final state = useStream(bloc.skip(1), initialData: bloc.value);
  return state.data;
}
